function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["width", "height", "borderRadius", "style", "children", "onChange", "timeBetweenScansMillis"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect, useImperativeHandle, useRef } from 'react';
import { BrowserMultiFormatReader, NotFoundException } from '@zxing/library';
import "./index.less";
/**
 * 二维码条形码扫描组件
 */
var PisellScan = /*#__PURE__*/forwardRef(function (props, ref) {
  var width = props.width,
    height = props.height,
    borderRadius = props.borderRadius,
    style = props.style,
    children = props.children,
    onChange = props.onChange,
    _props$timeBetweenSca = props.timeBetweenScansMillis,
    timeBetweenScansMillis = _props$timeBetweenSca === void 0 ? 500 : _props$timeBetweenSca,
    others = _objectWithoutProperties(props, _excluded);
  var videoRef = useRef(null);
  var codeReaderRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      codeReader: codeReaderRef.current
    };
  });
  useEffect(function () {
    var codeReader = new BrowserMultiFormatReader(undefined, timeBetweenScansMillis);
    // 将 codeReader 实例保存到 ref 对象中
    codeReaderRef.current = codeReader;
    var selectedDeviceId;
    codeReaderRef.current.listVideoInputDevices().then(function (videoInputDevices) {
      // 选择第一个视频输入设备
      selectedDeviceId = videoInputDevices[0].deviceId;

      // 使用所选的视频设备和 videoRef 中的视频元素进行解码
      codeReader.decodeFromVideoDevice(null, videoRef.current, function (result, err) {
        // 如果解码成功，调用 onChange 回调并传递解码结果的文本
        if (result) {
          onChange === null || onChange === void 0 ? void 0 : onChange(result.getText());
        }
        // 如果解码出错且错误不是 NotFoundException，则输出错误到控制台
        if (err && !(err instanceof NotFoundException)) {
          console.error(err);
        }
      });
      // codeReader.reset();
    }).catch(function (err) {
      console.error(err);
    });
    return function () {
      // 重置 codeReader，停止解码和释放资源
      codeReaderRef.current.reset();
    };
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    className: "pisell-scan-wrap",
    style: _objectSpread({
      width: width,
      height: height,
      borderRadius: borderRadius
    }, style)
  }, /*#__PURE__*/React.createElement("video", _extends({}, others, {
    ref: videoRef,
    style: _objectSpread({
      width: width,
      height: height,
      borderRadius: borderRadius,
      background: '#000'
    }, style)
  })), /*#__PURE__*/React.createElement("div", {
    className: "pisell-scan-action"
  }, children));
});
export default PisellScan;